package je.tn5250j;

import java.awt.*;
import java.io.*;
import javax.swing.*;
import je.tn5250j.tools.*;
import je.tn5250j.keyboard.configure.KeyConfigure;
import je.tn5250j.keyboard.configure.KeyConfigure_new;

/**
 * @author user
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class SubCommand {

	/**
	 * Constructor for SubCommand.
	 */
	public SubCommand() {
		super();
	}

	public static void mapMeKeys(Session session) {
		KeyConfigure kc;
		//KeyConfigure_new kc;

		Frame parent = (Frame) SwingUtilities.getRoot(session);

		if (Macronizer.isMacrosExist()) {
			String[] macrosList = Macronizer.getMacroList();
			kc = new KeyConfigure(parent, macrosList, session.getVT().getCodePage(), session.keyHandler);
			//kc = new KeyConfigure_new(parent, macrosList, session.getVT().getCodePage(), session.keyHandler);
		} else
			kc = new KeyConfigure(parent, null, session.getVT().getCodePage(), session.keyHandler);
			//kc = new KeyConfigure_new(parent, null, session.getVT().getCodePage(), session.keyHandler);

	}

	public static void doTransfer(Session session) {

		XTFRFile xtrf =
			new XTFRFile((Frame) SwingUtilities.getRoot(session), session.getVT(), session);

	}

	public static void doMHelp() {
		String cmd= System.getProperty("os.name").equals("Windows 98") ? "command" : "cmd";
		String epath= GlobalConfigure.instance().getProperty("emul.path", "");
		Runtime rt= Runtime.getRuntime();
		try {
			rt.exec(cmd + " /C \"" + epath + "manual.pdf\"");
		} catch (IOException ie) {
			System.out.println(ie.toString());
		}
	}

	public static void changeConnection(Session session) {

		final tnvt vt= session.getVT();
		if (vt.isConnected()) {

			vt.disconnect();

		} else {
			// lets set this puppy up to connect within its own thread
			Runnable connectIt = new Runnable() {
				public void run() {
					vt.connect();
				}

			};

			// now lets set it to connect within its own daemon thread
			//    this seems to work better and is more responsive than using
			//    swingutilities's invokelater
			Thread ct = new Thread(connectIt);
			ct.setDaemon(true);
			ct.start();

		}

	}

}
